' Demo fr die Grafikeinheit EA GE240-7KV24
' Darstellung von 8 Bargraphs als Sinuswelle

DECLARE SUB clrlcd ()
DECLARE SUB rahmen (x1!, y1!, x2!, y2!)
DECLARE SUB textmodus (richtung!, modus!, muster!)
DECLARE SUB font (fontnr!, zoomx!, zoomy!)
DECLARE SUB stringout (x!, y!, text$)
DECLARE SUB defbar (barnr!, x1!, y1!, x2!, y2!, aw!, ew!, mst!)
DECLARE SUB bar (barnr!, barwert!)

PRINT "****************************************************************"
PRINT "*  Darstellung von 8 Bargraphs auf dem Display als Sinuswelle  *"
PRINT "****************************************************************"

' Zuerst einmal COM2 initialisieren und Ausgabekanal #1 zuweisen
OPEN "COM2:9600,N,8,1,BIN" FOR OUTPUT AS #1

CALL clrlcd                              ' Display lschen
CALL rahmen(0, 0, 239, 127)              ' Rechteck zeichnen
CALL font(3, 2, 2)                       ' Zeichensatz 8x16, 2-fach ZOOM
CALL stringout(15, 1, "BARGRAPH DEMO")   ' berschrift ausgeben

FOR barnr = 1 TO 8                       ' die 8 Bar's definieren
   x = (barnr - 1) * 28 + 9
   CALL defbar(barnr, x, 36, x + 24, 126, 0, 100, (barnr MOD 7) + 1)
NEXT

PRINT "Abbruch durch Tastendruck"

winkel = 0                               ' 8 Bars als Sinuswelle darstellen
WHILE (INKEY$ = "")
   FOR barnr = 1 TO 8
      barwert = 46 * (SIN((winkel + barnr * 30) * 3.14 / 180) + 1) + 8
      CALL bar(barnr, barwert)
   NEXT
   winkel = winkel + 3
   IF (winkel >= 360) THEN
      winkel = 0
   END IF
WEND

CLOSE #1

END

SUB bar (barnr, barwert)
    PRINT #1, "B"; CHR$(barnr); CHR$(barwert)
END SUB

SUB clrlcd
    PRINT #1, "DL"
END SUB

SUB defbar (barnr, x1, y1, x2, y2, aw, ew, mst)
    PRINT #1, "BO"; CHR$(barnr); CHR$(x1); CHR$(y1); CHR$(x2); CHR$(y2); CHR$(aw); CHR$(ew); CHR$(mst)
END SUB

SUB font (fontnr, zoomx, zoomy)
    PRINT #1, "F"; CHR$(fontnr); CHR$(zoomx); CHR$(zoomy)
END SUB

SUB rahmen (x1, y1, x2, y2)
    PRINT #1, "R"; CHR$(x1); CHR$(y1); CHR$(x2); CHR$(y2)
END SUB

SUB stringout (x, y, text$)
    PRINT #1, "Z"; CHR$(x); CHR$(y); text$; CHR$(0)
END SUB

SUB textmodus (richtung, modus, muster)
    PRINT #1, "T"; CHR$(richtung); CHR$(modus); CHR$(muster)
END SUB

